Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QNucleus.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QNucleus.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QNucleus.cc	(revision 1055)
@@ -25,11 +25,15 @@
 //
 //
-// $Id: G4QNucleus.cc,v 1.95 2008/03/31 20:30:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QNucleus.cc,v 1.96 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QNucleus ----------------
 //             by Mikhail Kossov, Sept 1999.
 //      class for Nuclei/Nuclear Environment used by CHIPS Model
-// ------------------------------------------------------------------
+// ---------------------------------------------------------------------
+// Short description: a class describing properties of nuclei, which
+// are necessary for the CHIPS Model.
+// ---------------------------------------------------------------------
+
 
 //#define debug
@@ -56,6 +60,6 @@
 
 G4QNucleus::G4QNucleus(): G4QHadron(),Z(0),N(0),S(0),dZ(0),dN(0),dS(0),maxClust(0),
-			  currentNucleon(-1),rho0(0),radius(0)
-  //  probVect(),theImpactParameter(),theNucleons(), currentNucleon(-1),rho0(),radius(),Tb()
+     currentNucleon(-1),rho0(0),radius(0)
+   //probVect(),theImpactParameter(),theNucleons(), currentNucleon(-1),rho0(),radius(),Tb()
 {
   //Tb = new std::vector<G4double>;
@@ -115,5 +119,5 @@
 G4QNucleus::G4QNucleus(G4LorentzVector p, G4int nucPDG): G4QHadron(nucPDG,p),maxClust(0),
   currentNucleon(-1),rho0(0),radius(0)
-  //  probVect(),theImpactParameter(),theNucleons(), currentNucleon(-1),rho0(),radius(),Tb()
+  //probVect(),theImpactParameter(),theNucleons(), currentNucleon(-1),rho0(),radius(),Tb()
 {
   //Tb = new std::vector<G4double>;
@@ -324,5 +328,5 @@
   clustProb=c;
   mediRatio=d;
-		nucleonDistance=e;
+  nucleonDistance=e;
 }
 
@@ -353,4 +357,5 @@
   probVect[0]=mediRatio;                        // init Vacuum/Medium probability
   for(G4int i=1; i<256; i++) {probVect[i] = 0.;}
+  //std::uninitialized_fill( probVect+1, probVect+256, 0.0 ); // Worse in performance!
   if(nucPDG<80000000) nucPDG=HadrToNucPDG(nucPDG); // Convert HadrPDGCode to NucPDGCode
   G4int s=0;
@@ -375,5 +380,5 @@
     SetNFragments(0);
 #ifdef debug
-	   G4cout<<"G4QNucleus::InitByPDG:->QPDG="<<nPDG<<": 4M="<<p<<G4endl;
+    G4cout<<"G4QNucleus::InitByPDG:->QPDG="<<nPDG<<": 4M="<<p<<G4endl;
 #endif
   }
@@ -426,5 +431,5 @@
   if (din && dA<2 && a>2)
   {
-	   dA=2;
+    dA=2;
     sA=a-2;
   }
@@ -480,5 +485,5 @@
     sum =prb;
 #ifdef pdebug
-	  G4cout<<"G4QNucl::UpdateCl:sud="<<sud<<",v[1]=s="<<sum<<",dA="<<dA<<",uA="<<uA<<G4endl;
+   G4cout<<"G4QNucl::UpdateCl:sud="<<sud<<",v[1]=s="<<sum<<",dA="<<dA<<",uA="<<uA<<G4endl;
 #endif
     //probVect[1]= prb/comb;                   // a#of quasi-free nucleons (correct)
@@ -494,5 +499,5 @@
     sum+=prb+prb;
 #ifdef pdebug
-	G4cout<<"G4QNucl::UpdateCl:sud="<<sud<<",v[2]="<<prb<<",s="<<sum<<",pA="<<pA<<G4endl;
+    G4cout<<"G4QNucl::UpdateCl:sud="<<sud<<",v[2]="<<prb<<",s="<<sum<<",pA="<<pA<<G4endl;
 #endif
     //probVect[2]= prb/comb;                   // a#of quasi-free "dibaryons" (correct)
@@ -504,5 +509,5 @@
     maxi=3;
 #ifdef debug
-	G4cout<<"G4QNucleus::UpdateClusters:p1="<<probVect[1]<<", p2="<<probVect[2]<<",sA="<<sA
+    G4cout<<"G4QNucleus::UpdateClusters:p1="<<probVect[1]<<", p2="<<probVect[2]<<",sA="<<sA
           <<",uA="<<uA<<",pA="<<pA<<",wrd="<<wrd<<",sud="<<sud<<G4endl;
 #endif
@@ -518,5 +523,5 @@
         sum+=rd*i;
 #ifdef pdebug
-	    G4cout<<"G4QNucleus::UpdateCl:sud="<<sud<<", v["<<i<<"]="<<rd<<", s="<<sum<<G4endl;
+     G4cout<<"G4QNucleus::UpdateCl:sud="<<sud<<", v["<<i<<"]="<<rd<<", s="<<sum<<G4endl;
 #endif
         //comb*=(itA-i)/i;
@@ -529,5 +534,5 @@
 #endif
       }
-	   }
+    }
     dS = S;                                  // @@ Lambdas are always in the dense region
     dZ = static_cast<int>(static_cast<double>((dA-dS)*Z)/(Z+N) + 0.5);
@@ -555,5 +560,5 @@
   //          <<G4endl;
   //#endif
-  //	G4int m=RandomizeBinom(prob,jmax);     // A#of clusters of this type
+  // G4int m=RandomizeBinom(prob,jmax);     // A#of clusters of this type
   //    if(m)
   //    {
@@ -595,11 +600,11 @@
     {
       //if(abs(newPDG)<NUCPDG)
-	  //{
+      //{
       //  G4cerr<<"***G4QNucleus::Reduce:iPDG="<<curPDG<<"=newPDG="<<newPDG<<"+cPDG="<<cPDG
       //        <<G4endl;
       //  throw G4QException("*E*:::G4QNucleus::Reduce: Abnormal Nuclear Reduction");
-	  //}
+      //}
       InitByPDG(newPDG);                         // Reinit the Nucleus
-	}
+ }
   }
   else if(cPDG!=NUCPDG) G4cerr<<"***G4QN::Reduce:Subtract not nuclear PDGC="<<cPDG<<G4endl;
@@ -946,5 +951,5 @@
         {
           G4cerr<<"***G4QNucl::EvapBary: tM="<<totMass<<"-> 2N="<<nucPDG<<"(M="
-		        <<nucM<<") + pi="<<piPDG<<"(M="<<mPi<<")"<<G4endl;
+          <<nucM<<") + pi="<<piPDG<<"(M="<<mPi<<")"<<G4endl;
           //throw G4QException("G4QNucl::EvapBary:ISO-dibaryon DecayIn3 did not succeed");
           return false;
@@ -1131,22 +1136,22 @@
       pp2m=(tM2-mpls*mpls)*(tM2-mmin*mmin)/qtM2;
       if(pp2m>=0.000001)
-	     {
+      {
         pFlag=true;
         pBnd=mProt-GSMass+GSResNp;             // Binding energy for proton
         G4double eMax=sqrt(mP2+pp2m);
 #ifdef pdebug
-	       G4cout<<"G4QNuc::EvapBaryon:pm="<<eMax+sqrt(pp2m+GSResNp*GSResNp)<<" = M="<<totMass
+        G4cout<<"G4QNuc::EvapBaryon:pm="<<eMax+sqrt(pp2m+GSResNp*GSResNp)<<" = M="<<totMass
               <<", sm="<<GSResNp+mProt+PBarr<<",pp2="<<pp2m<<",pB="<<pBnd<<G4endl;
 #endif
         pExcess=eMax-mProt+pBnd;               // Max Kin Energy from bottom
-	     }
+      }
       else pExcess=pBnd;
       if(Z>1)
-	     {
+      {
         ppQPDG=G4QPDGCode(90000000+1000*(1000*S+Z-2)+N);
         GSResPP=ppQPDG.GetMass();
 #ifdef pdebug
         G4double sm=GSResPP+mProt+mProt+SPPBarr;
-	       G4cout<<"G4QNucl::EvapBaryon: ppM="<<GSResPP<<",T="<<sm-GSMass<<",E="<<totMass-sm
+        G4cout<<"G4QNucl::EvapBaryon: ppM="<<GSResPP<<",T="<<sm-GSMass<<",E="<<totMass-sm
               <<",C="<<PBarr<<G4endl;
 #endif
@@ -1162,8 +1167,8 @@
 #ifdef pdebug
             G4double s=GSResPA+mAlph+mProt+SAPBarr;
-	           G4cout<<"G4QN::EB:paM="<<GSResPA<<",T="<<s-GSMass<<",E="<<totMass-s<<G4endl;
+            G4cout<<"G4QN::EB:paM="<<GSResPA<<",T="<<s-GSMass<<",E="<<totMass-s<<G4endl;
 #endif
             if(GSResPA+mProt+SAPBarr+mAlph<totMass) paFlag=true;
-		        }
+          }
         }
         if(N>0&&a>3)
@@ -1171,10 +1176,10 @@
           GSReNPP=G4QPDGCode().GetNuclMass(Z-2,N-1,S);
           if(GSReNPP+mProt+mProt+SPPBarr+mNeut<totMass) nppF=true;
-		      }
+        }
         if(S>0&&a>3)
         {
           GSRePPL=G4QPDGCode().GetNuclMass(Z-2,N,S-1);
           if(GSRePPL+mProt+mProt+SPPBarr+mLamb<totMass) pplF=true;
-		      }
+        }
         if(N>1&&a>4)
         {
@@ -1185,30 +1190,30 @@
               GSReLLA=G4QPDGCode().GetNuclMass(Z-2,N-2,S-2);
               if(GSReLLA+mAlph+ABarr+mLamb+mLamb<totMass) llaF=true;
-		          }
+            }
             if(N>2&&S>0)
             {
               GSReNLA=G4QPDGCode().GetNuclMass(Z-2,N-3,S-1);
               if(GSReNLA+mAlph+ABarr+mNeut+mLamb<totMass) nlaF=true;
-		          }
+            }
             if(Z>2&&S>0)
             {
               GSRePLA=G4QPDGCode().GetNuclMass(Z-3,N-2,S-1);
               if(GSRePLA+mAlph+SAPBarr+mProt+mLamb<totMass) plaF=true;
-		          }
+            }
             if(N>3)
             {
               GSReNNA=G4QPDGCode().GetNuclMass(Z-2,N-4,S);
               if(GSReNNA+mAlph+ABarr+mNeut+mNeut<totMass) nnaF=true;
-		          }
+            }
             if(Z>2&&N>2)
             {
               GSReNPA=G4QPDGCode().GetNuclMass(Z-3,N-3,S);
               if(GSReNPA+mAlph+SAPBarr+mProt+mNeut<totMass) npaF=true;
-		          }
+            }
             if(N>3)
             {
               GSRePPA=G4QPDGCode().GetNuclMass(Z-4,N-2,S);
               if(GSRePPA+mAlph+SPPABarr+mProt+mProt<totMass) ppaF=true;
-		          }
+            }
             if(a>9)
             {
@@ -1233,6 +1238,6 @@
                 if(GSReAAA+mAlph+mAlph+mAlph+SAAABarr<totMass) aaaF=true;
               }
-			         }
-		        }
+            }
+          }
           if(N>3&&Z>3&&a>8)
           {
@@ -1241,9 +1246,9 @@
 #ifdef pdebug
             G4double s=GSResAA+mAlph+mAlph+SAABarr;
-	           G4cout<<"G4QNucl::EvapBaryon: a="<<GSResNP<<",T="<<s-GSMass<<",E="<<totMass-s
+            G4cout<<"G4QNucl::EvapBaryon: a="<<GSResNP<<",T="<<s-GSMass<<",E="<<totMass-s
                   <<",A="<<SAABarr<<G4endl;
 #endif
             if(GSResAA+mAlph+mAlph+SAABarr<totMass) aaFlag=true;
-		        }
+          }
           if(N>2&&a>5)
           {
@@ -1252,9 +1257,9 @@
 #ifdef pdebug
             G4double s=GSResNA+mAlph+mNeut;
-	           G4cout<<"G4QNucl::EvapBary: M="<<GSResNA<<",T="<<s-GSMass<<",E="<<totMass-s
+            G4cout<<"G4QNucl::EvapBary: M="<<GSResNA<<",T="<<s-GSMass<<",E="<<totMass-s
                   <<",C="<<ABarr<<G4endl;
 #endif
             if(GSResNA+mNeut+mAlph+ABarr<totMass) naFlag=true;
-		        }
+          }
           if(S>0&&a>5)
           {
@@ -1262,5 +1267,5 @@
             GSResLA=laQPDG.GetMass();
             if(GSResLA+mLamb+mAlph+ABarr<totMass) laFlag=true;
-		        }
+          }
           AQPDG =G4QPDGCode(90000000+1000*(1000*S+Z-2)+N-2);
           GSResNa=AQPDG.GetMass();
@@ -1269,19 +1274,19 @@
           ap2m=(tM2-mpls*mpls)*(tM2-mmin*mmin)/qtM2;
           if(ap2m>=0.000001)
-	         {
+          {
             aFlag=true;
             aBnd=mAlph-GSMass+GSResNa;           // Binding energy for ALPHA
             G4double eMax=sqrt(mA2+ap2m);
 #ifdef pdebug
-	           G4cout<<"G4QNuc::EvapBar:m="<<eMax+sqrt(ap2m+GSResNa*GSResNa)<<" = M="<<totMass
+            G4cout<<"G4QNuc::EvapBar:m="<<eMax+sqrt(ap2m+GSResNa*GSResNa)<<" = M="<<totMass
                   <<", sm="<<GSResNp+mProt+PBarr<<",pp2="<<pp2m<<",pB="<<pBnd<<G4endl;
 #endif
             aExcess=eMax-mAlph+aBnd;             // Max Kin Energy from bottom
-	         }
+          }
           else aExcess=pBnd;
-		      }
-	     }
+        }
+      }
       if(N>0)
-	     {
+      {
         if(Z>0)
         {
@@ -1290,22 +1295,22 @@
 #ifdef pdebug
           G4double s=GSResNP+mNeut+mProt;
-	         G4cout<<"G4QNucl::EvapBaryon: npM="<<GSResNP<<",T="<<s-GSMass<<",E="<<totMass-s
+          G4cout<<"G4QNucl::EvapBaryon: npM="<<GSResNP<<",T="<<s-GSMass<<",E="<<totMass-s
                 <<",C="<<PBarr<<G4endl;
 #endif
           if(GSResNP+mNeut+mProt+PBarr<totMass) npFlag=true;
-		      }
+        }
         if(N>1)
         {
           GSReNNP=G4QPDGCode().GetNuclMass(Z-1,N-2,S);
           if(GSReNNP+mProt+PBarr+mNeut+mNeut<totMass) nnpF=true;
-		      }
+        }
         if(S>0)
         {
           GSReNPL=G4QPDGCode().GetNuclMass(Z-1,N-1,S-1);
           if(GSReNPL+mProt+PBarr+mNeut+mLamb<totMass) nplF=true;
-		      }
-	     }
+        }
+      }
       if(S>0)
-	     {
+      {
         if(Z>0)
         {
@@ -1313,12 +1318,12 @@
           GSResPL=plQPDG.GetMass();
           if(GSResPL+mProt+PBarr+mLamb<totMass) plFlag=true;
-		      }
+        }
         if(S>1)
         {
           GSRePLL=G4QPDGCode().GetNuclMass(Z-1,N,S-2);
           if(GSRePLL+mProt+PBarr+mLamb+mLamb<totMass) pllF=true;
-		      }
-	     }
-	   }
+        }
+      }
+    }
     G4double GSResNn= GSMass;         // Prototype of Residual Nuclear Mass for neutron
     G4double nExcess= 0.;             // Prototype of excess energy for neutron
@@ -1330,5 +1335,5 @@
       GSResNn=NQPDG.GetMass();
 #ifdef pdebug
-	     G4cout<<"G4QNucleus::EvapBaryon: M(A-N)="<<GSResNn<<",Z="<<Z
+      G4cout<<"G4QNucleus::EvapBaryon: M(A-N)="<<GSResNn<<",Z="<<Z
             <<",N="<<N<<",S="<<S<<G4endl;
 #endif
@@ -1346,8 +1351,8 @@
 #endif
         nExcess=eMax-mNeut+nBnd;
-	     }
+      }
       else nExcess=nBnd;
       if(N>1)
-	     {
+      {
         nnQPDG=G4QPDGCode(90000000+1000*(1000*S+Z)+N-2);
         GSResNN=nnQPDG.GetMass();
@@ -1357,13 +1362,13 @@
           GSReNNN=G4QPDGCode().GetNuclMass(Z,N-3,S);
           if(GSReNNN+mNeut*3<totMass) nnnF=true;
-		      }
+        }
         if(S>0)
         {
           GSReNNL=G4QPDGCode().GetNuclMass(Z,N-2,S-1);
           if(GSReNNL+mNeut+mNeut+mLamb<totMass) nnlF=true;
-		      }
-	     }
+        }
+      }
       if(S>0)
-	     {
+      {
         nlQPDG=G4QPDGCode(90000000+1000*(1000*(S-1)+Z)+N-1);
         GSResNL=nlQPDG.GetMass();
@@ -1373,7 +1378,7 @@
           GSReNLL=G4QPDGCode().GetNuclMass(Z,N-1,S-2);
           if(GSReNLL+mNeut+mLamb+mLamb<totMass) nllF=true;
-		      }
-	     }
-	   }
+        }
+      }
+    }
     G4double GSResNl= GSMass;         // Prototype of Residual Nuclear Mass for Lambda
     G4double lExcess= 0.;             // Prototype of excess energy for Lambda
@@ -1397,8 +1402,8 @@
 #endif
         lExcess=eMax-mLamb+lBnd;
-	     }
+      }
       else lExcess=lBnd;
       if(S>1)
-	     {
+      {
         llQPDG=G4QPDGCode(90000000+1000*(1000*(S-2)+Z)+N);
         GSResLL=llQPDG.GetMass();
@@ -1408,7 +1413,7 @@
           GSReLLL=G4QPDGCode().GetNuclMass(Z,N,S-3);
           if(GSReLLL+mLamb*3<totMass) lllF=true;
-		      }
-	     }
-	   }
+        }
+      }
+    }
     G4bool nSecF = nnFlag||npFlag||nlFlag||naFlag; // Pos of second radiation after neutron
     G4bool pSecF = npFlag||ppFlag||plFlag||paFlag; // Pos of second radiation after proton
@@ -1422,5 +1427,5 @@
     //G4bool thdB  = nTrF||pTrF||lTrF||aTrF||naaF||paaF||laaF||aaaF;// Pos to radiate three
 #ifdef pdebug
-	   G4cout<<"G4QNucl::EvapBary:n="<<nSecF<<",p="<<pSecF<<",l="<<lSecF<<",a="<<aSecF<<",nn="
+    G4cout<<"G4QNucl::EvapBary:n="<<nSecF<<",p="<<pSecF<<",l="<<lSecF<<",a="<<aSecF<<",nn="
           <<nnFlag<<", np="<<npFlag<<",pp="<<ppFlag<<",pa="<<paFlag<<",na="<<naFlag<<",aa="
           <<aaFlag<<G4endl;
@@ -1428,6 +1433,6 @@
     G4QPDGCode bQPDG;
     G4QPDGCode rQPDG;
-	   if(secB)                            // Decay in two baryons is possible
-	   //if(thdB)                            //@@CHECK@@ Decay in three baryons is possible
+    if(secB)                            // Decay in two baryons is possible
+    //if(thdB)                            //@@CHECK@@ Decay in three baryons is possible
     {
       if(!nSecF) nFlag=false;
@@ -1436,5 +1441,5 @@
       if(!aSecF) aFlag=false;
 #ifdef pdebug
-	     G4cout<<"G4QNuc::EB:nF="<<nFlag<<",pF="<<pFlag<<",lF="<<lFlag<<",aF="<<aFlag<<G4endl;
+      G4cout<<"G4QNuc::EB:nF="<<nFlag<<",pF="<<pFlag<<",lF="<<lFlag<<",aF="<<aFlag<<G4endl;
 #endif
       G4double maxE=0.;                          // Prototype for maximum energy
@@ -1475,9 +1480,9 @@
         G4double ma=uWell*a+maxE;        // Total Kinetic Energy of baryons (@@alphas?)
         if(mi<0.)
-	       {
+        {
           uW-=mi;
           mm-=mi;
           mi=0.;
-	       }
+        }
         G4bool good=true;
         if(ma<mm)
@@ -1487,5 +1492,5 @@
         }
 #ifdef pdebug
-	       G4cout<<"G4QNuc::EvapBary:iE="<<minE<<",aE="<<maxE<<",mi="<<mi<<",mm="<<mm<<",ma="
+        G4cout<<"G4QNuc::EvapBary:iE="<<minE<<",aE="<<maxE<<",mi="<<mi<<",mm="<<mm<<",ma="
               <<ma<<G4endl;
 #endif
@@ -1500,5 +1505,5 @@
         if(xMi>xMa)
         {
-	         G4cerr<<"***G4QNucleus::EvapBaryon: M="<<mm/ma<<",xi="<<xMi<<",xa="<<xMa<<G4endl;
+          G4cerr<<"***G4QNucleus::EvapBaryon: M="<<mm/ma<<",xi="<<xMi<<",xa="<<xMa<<G4endl;
           return false;
         }
@@ -1506,5 +1511,5 @@
         xMa=sqrt(xMa);                          // @@ ?
 #ifdef pdebug
-	       G4cout<<"G4QNuc:EvapBaryon:mi="<<mi<<",ma="<<ma<<", xi="<<xMi<<",xa="<<xMa<<G4endl;
+        G4cout<<"G4QNuc:EvapBaryon:mi="<<mi<<",ma="<<ma<<", xi="<<xMi<<",xa="<<xMa<<G4endl;
 #endif
         G4double powr=1.5*a1;                   // Power for low & up limits
@@ -1528,5 +1533,5 @@
           G4double x = sqrt(x2);
           if(x<xMi||x>xMa)
-		        {
+          {
 #ifdef pdebug
             G4cerr<<"**G4QNucl::EvapB:R="<<R<<",xi="<<xMi<<" < "<<x<<" < xa="<<xMa<<G4endl;
@@ -1535,5 +1540,5 @@
             else      x=xMa;
             x2 = x*x;
-		        }
+          }
           G4double rn=G4UniformRand();
           //if(rn<x/xMa||!good)
@@ -1544,5 +1549,5 @@
             G4double zCBPP=0.;                         // Probabylity for a proton
 #ifdef pdebug
-			         G4cout<<"G4QNuc::EvapB:t="<<tk<<",pM="<<pMin<<",pB="<<pBnd<<",n="<<nMin<<",a="
+            G4cout<<"G4QNuc::EvapB:t="<<tk<<",pM="<<pMin<<",pB="<<pBnd<<",n="<<nMin<<",a="
                   <<aMin<<G4endl;
 #endif
@@ -1552,9 +1557,9 @@
               //if(barf) kin-=PBarr; //@@ This is a mistake
 #ifdef pdebug
-			           G4cout<<"G4QN::EB:Proton="<<kin<<",CB="<<PBarr<<",B="<<pBnd<<",M="<<pMin
+              G4cout<<"G4QN::EB:Proton="<<kin<<",CB="<<PBarr<<",B="<<pBnd<<",M="<<pMin
                     <<",p="<<CoulBarPenProb(PBarr,kin,1,1)<<G4endl;
 #endif
               zCBPP=Z*CoulBarPenProb(PBarr,kin,1,1)*sqrt(kin);
-			         }
+            }
             psum+=zCBPP;
             G4double nCBPP=0.;                       // Probability for a neutron (=> p+n)
@@ -1563,5 +1568,5 @@
               G4double kin=tk-nBnd;
 #ifdef pdebug
-			           G4cout<<"G4QN::EB:Neutron="<<kin<<",p="<<CoulBarPenProb(0.,kin,0,1)<<G4endl;
+              G4cout<<"G4QN::EB:Neutron="<<kin<<",p="<<CoulBarPenProb(0.,kin,0,1)<<G4endl;
 #endif
               nCBPP=N*CoulBarPenProb(0.,kin,0,1)*sqrt(kin);
@@ -1574,57 +1579,57 @@
               G4double kin=tk-lBnd;
 #ifdef pdebug
-			           G4cout<<"G4QN::EB:Lambda="<<kin<<",p="<<CoulBarPenProb(0,kin,0,1)<<G4endl;
+              G4cout<<"G4QN::EB:Lambda="<<kin<<",p="<<CoulBarPenProb(0,kin,0,1)<<G4endl;
 #endif
               lCBPP=S*CoulBarPenProb(0.,kin,0,1)*sqrt(kin);
-			         }
+            }
             psum+=lCBPP;
             lCBPP+=nCBPP;
-			         if(evalph&&aFlag&&tk>aMin)
+            if(evalph&&aFlag&&tk>aMin)
             {
               G4double kin=tk-aBnd;
               //if(barf) kin-=ABarr; //@@ This is a mistake
 #ifdef pdebug
-			           G4cout<<"G4QN::EB:Alpha="<<kin<<",CB="<<ABarr<<",p="
+              G4cout<<"G4QN::EB:Alpha="<<kin<<",CB="<<ABarr<<",p="
                     <<CoulBarPenProb(ABarr,kin,2,4)<<G4endl;
 #endif
               psum+=CoulBarPenProb(ABarr,kin,2,4)*sqrt(kin)*evalph*Z*(Z-1)*N*(N-1)
                                                  *6/a1/(a-2)/(a-3);
-			         }
+            }
             G4double r = psum*G4UniformRand();
 #ifdef pdebug
-			         G4cout<<"G4QNuc::EvapB:"<<r<<",p="<<zCBPP<<",pn="<<nCBPP<<",pnl="<<lCBPP<<",t="
+            G4cout<<"G4QNuc::EvapB:"<<r<<",p="<<zCBPP<<",pn="<<nCBPP<<",pnl="<<lCBPP<<",t="
                   <<psum<<G4endl;
 #endif
             cond = false;
             if     (r&&r>lCBPP)
-		          {
-#ifdef pdebug
-			           G4cout<<"G4QNuc::EvaB:ALPHA is selected for evap, r="<<r<<">"<<lCBPP<<G4endl;
+            {
+#ifdef pdebug
+              G4cout<<"G4QNuc::EvaB:ALPHA is selected for evap, r="<<r<<">"<<lCBPP<<G4endl;
 #endif
               PDG=aPDG;
-		          }
+            }
             else if(r&&r>nCBPP&&r<=lCBPP)
             {
 #ifdef pdebug
-			           G4cout<<"G4QNuc::EvaB:LAMBDA is selected for evap,r="<<r<<"<"<<lCBPP<<G4endl;
+              G4cout<<"G4QNuc::EvaB:LAMBDA is selected for evap,r="<<r<<"<"<<lCBPP<<G4endl;
 #endif
               PDG=lPDG;
-			         }
+            }
             else if(r&&r>zCBPP&&r<=nCBPP)
             {
 #ifdef pdebug
-			           G4cout<<"G4QNuc::EvaBar: N is selected for evapor,r="<<r<<"<"<<nCBPP<<G4endl;
+              G4cout<<"G4QNuc::EvaBar: N is selected for evapor,r="<<r<<"<"<<nCBPP<<G4endl;
 #endif
               PDG=nPDG;
-			         }
+            }
             else if(r&&r<=zCBPP)
             {
 #ifdef pdebug
-			           G4cout<<"G4QNuc::EvaBar: P is selected for evapor,r="<<r<<"<"<<zCBPP<<G4endl;
+              G4cout<<"G4QNuc::EvaBar: P is selected for evapor,r="<<r<<"<"<<zCBPP<<G4endl;
 #endif
               PDG=pPDG;
-			         }
+            }
             else cond=true;
-		        }
+          }
 #ifdef pdebug
           G4cout<<"G4QNuc::EvapBar:c="<<cond<<",x="<<x<<",cnt="<<cntr<<",R="<<R<<",ma="<<ma
@@ -1632,7 +1637,7 @@
 #endif
           cntr++;
-	       }
+        }
         if(cntr<cntm)                       // => Succeeded to find the evaporation channel
-	       {
+        {
           G4double p2=0.;
           if     (PDG==aPDG)
@@ -1644,9 +1649,9 @@
               p2=ap2m;
               tk=sqrt(p2+mA2);
-		          }
+            }
             eMass=mAlph;
             bQPDG=aQPDG;
             rQPDG=AQPDG;
-	         }
+          }
           else if(PDG==pPDG)
           {
@@ -1657,9 +1662,9 @@
               p2=pp2m;
               tk=sqrt(p2+mP2);
-		          }
+            }
             eMass=mProt;
             bQPDG=pQPDG;
             rQPDG=PQPDG;
-	         }
+          }
           else if(PDG==nPDG)
           {
@@ -1673,9 +1678,9 @@
               p2=np2m;
               tk=sqrt(p2+mN2);
-		          }
+            }
             eMass=mNeut;
             bQPDG=nQPDG;
             rQPDG=NQPDG;
-	         }
+          }
           else if(PDG==lPDG)
           {
@@ -1686,9 +1691,9 @@
               p2=lp2m;
               tk=sqrt(p2+mL2);
-		          }
+            }
             eMass=mLamb;
             bQPDG=lQPDG;
             rQPDG=LQPDG;
-	         }
+          }
           else G4cerr<<"***G4QNucleus::EvaporateBaryon: PDG="<<PDG<<G4endl;
           G4double rEn=totMass-tk;
@@ -1721,5 +1726,5 @@
           if(barf) aaCond = !aaFlag || (aaFlag && GSResAA+mAlph+SAABarr > rMass);
 #ifdef pdebug
-		        G4cout<<"G4QNucl::EvaB:"<<PDG<<", E="<<tk<<", rM="<<rMass<<", ";
+          G4cout<<"G4QNucl::EvaB:"<<PDG<<", E="<<tk<<", rM="<<rMass<<", ";
           if(PDG==pPDG)      G4cout<<"PN="<<GSResNP+mNeut<<"("<<pnCond<<"),PP="
                                    <<GSResPP+mProt+PPBarr<<"("<<ppCond<<"),PL="
@@ -1743,8 +1748,8 @@
           //if(3>2)three=false;                        // @@@@@@@@@@@@@@@@@@
           //else if(PDG==pPDG&&(pnCond&&ppCond&&plCond&&paCond)) // @@@@@@@@@@@@@@@@@@@
-		        if(PDG==pPDG&&(pnCond&&ppCond&&plCond&&paCond))//p+RN decay, p+b+RN dec is closed
-		        {
-#ifdef pdebug
-			         G4cout<<"G4QN::EB:*p*: n="<<pnCond<<",p="<<ppCond<<",l="<<plCond<<",a="<<paCond
+          if(PDG==pPDG&&(pnCond&&ppCond&&plCond&&paCond))//p+RN decay, p+b+RN dec is closed
+          {
+#ifdef pdebug
+            G4cout<<"G4QN::EB:*p*: n="<<pnCond<<",p="<<ppCond<<",l="<<plCond<<",a="<<paCond
                   <<G4endl;
 #endif
@@ -1753,31 +1758,31 @@
             G4double nLim=0.;
             if(N&&GSResNP!=GSMass&&fMass+PBarr+mNeut+GSResNP<totMass)
-			         {
-			           if(barf) nLim+=(N+N)*pow(totMass-mNeut-mProt-PBarr-GSResNP,2);
+            {
+              if(barf) nLim+=(N+N)*pow(totMass-mNeut-mProt-PBarr-GSResNP,2);
               else     nLim+=(N+N)*pow(totMass-mNeut-mProt-GSResNP,2);
-			         }
+            }
             G4double zLim=nLim;
             if(Z>1&&GSResPP!=GSMass&&fMass+mProt+SPPBarr+GSResPP<totMass)
-			         {
-			           if(barf) zLim+=(Z-1)*pow(totMass-mProt-mProt-SPPBarr-GSResPP,2);
+            {
+              if(barf) zLim+=(Z-1)*pow(totMass-mProt-mProt-SPPBarr-GSResPP,2);
               else     zLim+=(Z-1)*pow(totMass-mProt-mProt-GSResPP,2);
-			         }
+            }
             G4double sLim=zLim;
             if(S&&GSResPL!=GSMass&&fMass+PBarr+mLamb+GSResPL<totMass)
-			         {
-			           if(barf) sLim+=(S+S)*pow(totMass-mProt-mLamb-PBarr-GSResPL,2);
+            {
+              if(barf) sLim+=(S+S)*pow(totMass-mProt-mLamb-PBarr-GSResPL,2);
               else     sLim+=(S+S)*pow(totMass-mProt-mLamb-GSResPL,2);
-			         }
+            }
             G4double aLim=sLim;
             if(evalph&&Z>2&&N>1&&a>4&&GSResPL!=GSMass&&fMass+SAPBarr+mAlph+GSResPA<totMass)
-			         {
-			           if(barf) aLim+=pow(totMass-mProt-mAlph-SAPBarr-GSResPA,2)*evalph*
+            {
+              if(barf) aLim+=pow(totMass-mProt-mAlph-SAPBarr-GSResPA,2)*evalph*
                              (Z-1)*(Z-2)*N*(N-1)*12/(a-2)/(a-3)/(a-4);
               else     aLim+=pow(totMass-mProt-mAlph-GSResPA,2)*evalph*(Z-1)*(Z-2)*N*(N-1)
                              *12/(a-2)/(a-3)/(a-4);
-			         }
+            }
             G4double r = aLim*G4UniformRand();
 #ifdef pdebug
-			         G4cout<<"G4QNuc::EvaB:p, r="<<r<<",n="<<nLim<<",z="<<zLim<<",s="<<sLim<<",a="
+            G4cout<<"G4QNuc::EvaB:p, r="<<r<<",n="<<nLim<<",z="<<zLim<<",s="<<sLim<<",a="
                   <<aLim<<G4endl;
 #endif
@@ -1785,5 +1790,5 @@
             if(!aLim) three=false;
             else if(r>sLim)
-		          {
+            {
               eMass = mAlph;
               dbQPDG= PAQPDG;
@@ -1791,9 +1796,9 @@
               rQPDG = paQPDG;
 #ifdef pdebug
-			           G4cout<<"G4QNucleus::EvaporateBary: P+A"<<G4endl;
-#endif
-		          }
+              G4cout<<"G4QNucleus::EvaporateBary: P+A"<<G4endl;
+#endif
+            }
             else if(zLim<sLim&&r>zLim&&r<=sLim)
-		          {
+            {
               eMass = mLamb;
               dbQPDG= PLQPDG;
@@ -1801,9 +1806,9 @@
               rQPDG = plQPDG;
 #ifdef pdebug
-			           G4cout<<"G4QNucleus::EvaporateBary: P+L"<<G4endl;
-#endif
-		          }
+              G4cout<<"G4QNucleus::EvaporateBary: P+L"<<G4endl;
+#endif
+            }
             else if(nLim<zLim&&r>nLim&&r<=zLim)
-	           {
+            {
               eMass = mProt;
               dbQPDG= PPQPDG;
@@ -1811,9 +1816,9 @@
               rQPDG = ppQPDG;
 #ifdef pdebug
-			           G4cout<<"G4QNucleus::EvaporateBary: P+P"<<G4endl;
-#endif
-		          }
+              G4cout<<"G4QNucleus::EvaporateBary: P+P"<<G4endl;
+#endif
+            }
             else if(r<=nLim)
-	           {
+            {
               eMass = mNeut;
               dbQPDG= NPQPDG;
@@ -1821,13 +1826,13 @@
               rQPDG = npQPDG;
 #ifdef pdebug
-			           G4cout<<"G4QNucleus::EvaporateBary: P+N"<<G4endl;
-#endif
-   	        }
+              G4cout<<"G4QNucleus::EvaporateBary: P+N"<<G4endl;
+#endif
+            }
             else three=false;
-		        }
+          }
           else if(PDG==nPDG&&(nnCond&&npCond&&nlCond&&naCond)) // n+b+RN decay can't happen
-		        { //@@ Take into account Coulomb Barier Penetration Probability
-#ifdef pdebug
-			         G4cout<<"G4QN::EB:*n*: n="<<nnCond<<",p="<<npCond<<",l="<<nlCond<<",a="<<naCond
+          { //@@ Take into account Coulomb Barier Penetration Probability
+#ifdef pdebug
+            G4cout<<"G4QN::EB:*n*: n="<<nnCond<<",p="<<npCond<<",l="<<nlCond<<",a="<<naCond
                   <<G4endl;
 #endif
@@ -1839,8 +1844,8 @@
             G4double zLim=nLim;
             if(Z&&GSResNP!=GSMass&&fMass+mProt+PBarr+GSResNP<totMass)
-			         {
-			           if(barf) zLim+=(Z+Z)*pow(totMass-mNeut-mProt-PBarr-GSResNP,2);
+            {
+              if(barf) zLim+=(Z+Z)*pow(totMass-mNeut-mProt-PBarr-GSResNP,2);
               else     zLim+=(Z+Z)*pow(totMass-mNeut-mProt-GSResNP,2);
-			         }
+            }
             G4double sLim=zLim;
             if(S&&GSResNL!=GSMass&&fMass+mLamb+GSResNL<totMass)
@@ -1848,13 +1853,13 @@
             G4double aLim=sLim;
             if(evalph&&Z>1&&N>2&&a>4&&GSResNA!=GSMass&&fMass+mAlph+ABarr+GSResNA<totMass)
-			         {
-			           if(barf) aLim+=pow(totMass-mNeut-mAlph-ABarr-GSResNA,2)*
+            {
+              if(barf) aLim+=pow(totMass-mNeut-mAlph-ABarr-GSResNA,2)*
                              evalph*Z*(Z-1)*(N-1)*(N-2)*12/(a-2)/(a-3)/(a-4);
               else     aLim+=pow(totMass-mNeut-mAlph-GSResNA,2)*
                              evalph*Z*(Z-1)*(N-1)*(N-2)*12/(a-2)/(a-3)/(a-4);
-			         }
+            }
             G4double r = aLim*G4UniformRand();
 #ifdef pdebug
-			         G4cout<<"G4QN::EB:n, r="<<r<<",n="<<nLim<<",z="<<zLim<<",s="<<sLim<<",a="<<aLim
+            G4cout<<"G4QN::EB:n, r="<<r<<",n="<<nLim<<",z="<<zLim<<",s="<<sLim<<",a="<<aLim
                   <<G4endl;
 #endif
@@ -1862,5 +1867,5 @@
             if(!aLim) three=false;
             else if(r>sLim)
-		          {
+            {
               eMass = mAlph;
               dbQPDG= NAQPDG;
@@ -1868,9 +1873,9 @@
               rQPDG = naQPDG;
 #ifdef pdebug
-			           G4cout<<"G4QNucleus::EvaporateBary: N+A"<<G4endl;
-#endif
-		          }
+              G4cout<<"G4QNucleus::EvaporateBary: N+A"<<G4endl;
+#endif
+            }
             else if(zLim<sLim&&r>zLim&&r<=sLim)
-		          {
+            {
               eMass = mLamb;
               dbQPDG= NLQPDG;
@@ -1878,9 +1883,9 @@
               rQPDG = nlQPDG;
 #ifdef pdebug
-			           G4cout<<"G4QNucleus::EvaporateBary: N+L"<<G4endl;
-#endif
-		          }
+              G4cout<<"G4QNucleus::EvaporateBary: N+L"<<G4endl;
+#endif
+            }
             else if(nLim<zLim&&r>nLim&&r<=zLim)
-	           {
+            {
               eMass = mProt;
               dbQPDG= NPQPDG;
@@ -1888,9 +1893,9 @@
               rQPDG = npQPDG;
 #ifdef pdebug
-			           G4cout<<"G4QNucleus::EvaporateBary: N+P"<<G4endl;
-#endif
-		          }
+              G4cout<<"G4QNucleus::EvaporateBary: N+P"<<G4endl;
+#endif
+            }
             else if(r<=nLim)
-	           {
+            {
               eMass = mNeut;
               dbQPDG= NNQPDG;
@@ -1898,13 +1903,13 @@
               rQPDG = nnQPDG;
 #ifdef pdebug
-			           G4cout<<"G4QNucleus::EvaporateBary: N+N"<<G4endl;
-#endif
-   	        }     
+              G4cout<<"G4QNucleus::EvaporateBary: N+N"<<G4endl;
+#endif
+            }     
             else three=false;
-		        }
+          }
           else if(PDG==lPDG&&(lnCond&&lpCond&&llCond&&laCond)) // l+b+RN decay can't happen
-		        { //@@ Take into account Coulomb Barier Penetration Probability
+          { //@@ Take into account Coulomb Barier Penetration Probability
 #ifdef ppdebug
-			         G4cout<<"G4QN::EB:*l*: n="<<lnCond<<",p="<<lpCond<<",l="<<llCond<<",a="<<laCond
+            G4cout<<"G4QN::EB:*l*: n="<<lnCond<<",p="<<lpCond<<",l="<<llCond<<",a="<<laCond
                   <<G4endl;
 #endif
@@ -1916,8 +1921,8 @@
             G4double zLim=nLim;
             if(Z&&GSResPL!=GSMass&&fMass+mProt+PBarr+GSResPL<totMass)
-			         {
-			           if(barf) zLim+=(Z+Z)*pow(totMass-mProt-mLamb-PBarr-GSResPL,2);
+            {
+              if(barf) zLim+=(Z+Z)*pow(totMass-mProt-mLamb-PBarr-GSResPL,2);
               else zLim+=(Z+Z)*pow(totMass-mProt-mLamb-GSResPL,2);
-			         }
+            }
             G4double sLim=zLim;
             if(S>1&&GSResLL!=GSMass&&fMass+mLamb+GSResLL<totMass)
@@ -1925,13 +1930,13 @@
             G4double aLim=sLim;
             if(evalph&&Z>1&&N>1&&a>4&&GSResLA!=GSMass&&fMass+mAlph+ABarr+GSResLA<totMass)
-			         {
-			           if(barf) aLim+=pow(totMass-mLamb-mAlph-ABarr-GSResLA,2)*
+            {
+              if(barf) aLim+=pow(totMass-mLamb-mAlph-ABarr-GSResLA,2)*
                              evalph*Z*(Z-1)*N*(N-1)*12/(a-2)/(a-3)/(a-4);
               else     aLim+=pow(totMass-mLamb-mAlph-GSResLA,2)*
                              evalph*Z*(Z-1)*N*(N-1)*12/(a-2)/(a-3)/(a-4);
-			         }
+            }
             G4double r = aLim*G4UniformRand();
 #ifdef pdebug
-			         G4cout<<"G4QN::EB:l, r="<<r<<",n="<<nLim<<",z="<<zLim<<",s="<<sLim<<",a="<<aLim
+            G4cout<<"G4QN::EB:l, r="<<r<<",n="<<nLim<<",z="<<zLim<<",s="<<sLim<<",a="<<aLim
                   <<G4endl;
 #endif
